#!/usr/bin/python
# -*- coding: utf-8 -*-

import pythoncom

import win32com
import win32com.server.connect
import win32com.server.register
import win32com.server.util

IID_ITestServerEvents = pythoncom.MakeIID("{FA2A6031-9FEE-4B34-B6D1-7D4C157CEDCE}")
IID_ITestServer = pythoncom.MakeIID("{E67D7A83-C1AE-4ED8-BAA2-8C2AD982F400}")

class TestServer(win32com.server.connect.ConnectableServer):
    _reg_clsid_ = '{8F1F306D-E0F0-42A5-A114-399C4480A92B}'
    _reg_desc_ = 'My Description'
    _reg_progid_ = 'testproject.TestServer'
    _reg_verprogid_ = 'testproject.TestServer.1'
    
    _public_methods_ = ['fire_event'] + win32com.server.connect.ConnectableServer._public_methods_
    _connect_interfaces_ = [IID_ITestServerEvents]
    
    _reg_clsctx_ = pythoncom.CLSCTX_LOCAL_SERVER
    _reg_threading_ = 'Apartment'
    
    def __init__(self):
        self.status_text = 'a'
        win32com.server.connect.ConnectableServer.__init__(self)
    
    def _query_interface_(self, iid):
        if iid == IID_ITestServer:
            return win32com.server.util.wrap(self)
    
    def fire_event(self, arg):
        print "server: fire_event called", arg
        print self._BroadcastNotify(self.notify_OnMyEvent, (arg, ))
    
    def notify_OnMyEvent(self, interface, arg):
        print "server: event fired", arg
        interface.Invoke(1000, 0, pythoncom.DISPATCH_METHOD, 1, arg)



if __name__=='__main__':
    win32com.server.register.UseCommandLine(TestServer)


